
GenericJNIPortRegressionTest subclass: #JNIPortGeneratedAmbiguousSelectorsTest
	instanceVariableNames: 'instance classStatic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedAmbiguousSelectorsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedAmbiguousSelectorsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'AmbiguousSelectors'.! !

!JNIPortGeneratedAmbiguousSelectorsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	classStatic := self javaTestClass.
	instance := classStatic new.! !

!JNIPortGeneratedAmbiguousSelectorsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	classStatic := instance := nil.
	super tearDown.! !

!JNIPortGeneratedAmbiguousSelectorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testFallbackToLongForm

	self should: [instance longForm_Array: nil] raise: AmbiguousJavaMethodError.
	self should: [(instance longForm_javalangreflectArray: nil) asString = 'java.lang.reflect.Array'].
	self should: [(instance longForm_javasqlArray: nil) asString = 'java.sql.Array'].! !

!JNIPortGeneratedAmbiguousSelectorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:34'!
testFallbackToLongFormAndReturnType

	self should: [instance returnType_TestArray: nil] raise: AmbiguousJavaMethodError.
	self should: [(instance returnType_int_orgmetagnosticjniporttestregressionTestArray: nil)  = 2].
	self should: [(instance returnType_double_orgmetagnosticjniporttestregressionTestArray: nil)  = (Number readFromString: '3.14159d')].! !

!JNIPortGeneratedAmbiguousSelectorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testIncurableAmbiguity

	self should: [instance incurable_TestArray: nil] raise: AmbiguousJavaMethodError.

	"we have no idea which of the two methods is called here"
	#CUtodo.  "this should probably throw a MNU exception"
	instance incurable_void_orgmetagnosticjniporttestregressionTestArray: nil.! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedConstructorsTest
	instanceVariableNames: 'classStatic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedConstructorsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedConstructorsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
abstractClass

	^ self javaTestClass: 'AbstractClass'.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
derivedClass

	^ self javaTestClass: 'DerivedConstructors'.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
interface

	^ self javaTestClass: 'InheritedMethodsInterface'.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'Constructors'.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	classStatic := self javaTestClass.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	classStatic := nil.
	super tearDown.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testBooleanArgument

	self should: [(classStatic new_boolean: true) getText asString = 'boolean: true'].
	self should: [(classStatic new_boolean: false) getText asString = 'boolean: false'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testByteArgument

	self should: [(classStatic new_byte: 0) getText asString = 'byte: 0'].
	self should: [(classStatic new_byte: 100) getText asString = 'byte: 100'].
	self should: [(classStatic new_byte: -100) getText asString = 'byte: -100'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCharArgument

	self should: [(classStatic new_char: $!!) getText asString = 'char: !!'].
	self should: [(classStatic new_char: $A) getText asString = 'char: A'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testDerivedClassConstructor

	| new |

	new := self derivedClass new.

	self should: [new static = self derivedClass].
	self should: [new getText asString = 'String: derived'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:34'!
testDoubleArgument

	self should: [(classStatic new_double: 0.0 asDouble) getText asString = 'double: 0.0'].
	self should: [(classStatic new_double: 100.0 asDouble) getText asString = 'double: 100.0'].
	self should: [(classStatic new_double: -100.0 asDouble) getText asString = 'double: -100.0'].
	self should: [(classStatic new_double: 1000.0 asDouble) getText asString = 'double: 1000.0'].
	self should: [(classStatic new_double: -1000.0 asDouble) getText asString = 'double: -1000.0'].
	self should: [(classStatic new_double: 1000000.0 asDouble) getText asString = 'double: 1000000.0'].
	self should: [(classStatic new_double: -1000000.0 asDouble) getText asString = 'double: -1000000.0'].
	self should: [(classStatic new_double: (Number readFromString: '1000000000000.0d')) getText asString = 'double: 1.0E12'].		"JVM specific ??"
	self should: [(classStatic new_double: (Number readFromString: '-1000000000000.0d')) getText asString = 'double: -1.0E12'].		"JVM specific ??"! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testFloatArgument

	self should: [(classStatic new_float: 0.0 asFloat) getText asString = 'float: 0.0'].
	self should: [(classStatic new_float: 100.0 asFloat) getText asString = 'float: 100.0'].
	self should: [(classStatic new_float: -100.0 asFloat) getText asString = 'float: -100.0'].
	self should: [(classStatic new_float: 1000.0 asFloat) getText asString = 'float: 1000.0'].
	self should: [(classStatic new_float: -1000.0 asFloat) getText asString = 'float: -1000.0'].
	self should: [(classStatic new_float: 1000000.0 asFloat) getText asString = 'float: 1000000.0'].
	self should: [(classStatic new_float: -1000000.0 asFloat) getText asString = 'float: -1000000.0'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testInheritedConstructor

	| new exception |

	"different behaviour between ghost classes and statically generated wrappers in this case"
	exception := jvm usesGhostClasses
				ifTrue: [Error "i.e. ShouldNotImplement"]
				ifFalse: [self noSuchMethodExceptionClass].

	"JRockit wrongly answers an instance of the superclass"
	self
		should: [new := self derivedClass new_int: 1]
		raise: exception.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testInstantiateAbstractClass

	self
		should: [self abstractClass new_int: 1]
		raise: MessageNotUnderstood.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testInstantiateAbstractClassWithDefaultConstructor

	| new exception |

	"different behaviour between ghost classes and statically generated wrappers in this case"
	exception := jvm usesGhostClasses
				ifTrue: [Error "i.e. ShouldNotImplement"]
				ifFalse: [self instantiationExceptionClass].

	self
		should: [new := self abstractClass new]
		raise: exception.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testInstantiateConcreteClass

	| new |

	self
		shouldnt: [new := classStatic new]
		raise: MessageNotUnderstood.

	self should: [new static == classStatic].
	self should: [new isInstanceOf: classStatic].
	self should: [new getText asString = 'default'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testInstantiateInterface

	self
		should: [self interface new]
		raise: MessageNotUnderstood.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testIntArgument

	self should: [(classStatic new_int: 0) getText asString = 'int: 0'].
	self should: [(classStatic new_int: 100) getText asString = 'int: 100'].
	self should: [(classStatic new_int: -100) getText asString = 'int: -100'].
	self should: [(classStatic new_int: 1000) getText asString = 'int: 1000'].
	self should: [(classStatic new_int: -1000) getText asString = 'int: -1000'].
	self should: [(classStatic new_int: 1000000) getText asString = 'int: 1000000'].
	self should: [(classStatic new_int: -1000000) getText asString = 'int: -1000000'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testLongArgument

	self should: [(classStatic new_long: 0) getText asString = 'long: 0'].
	self should: [(classStatic new_long: 100) getText asString = 'long: 100'].
	self should: [(classStatic new_long: -100) getText asString = 'long: -100'].
	self should: [(classStatic new_long: 1000) getText asString = 'long: 1000'].
	self should: [(classStatic new_long: -1000) getText asString = 'long: -1000'].
	self should: [(classStatic new_long: 1000000) getText asString = 'long: 1000000'].
	self should: [(classStatic new_long: -1000000) getText asString = 'long: -1000000'].
	self should: [(classStatic new_long: 1000000000000) getText asString = 'long: 1000000000000'].
	self should: [(classStatic new_long: -1000000000000) getText asString = 'long: -1000000000000'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNoArguments

	self should: [(classStatic new) getText asString = 'default'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNullArgument

	self should: [(classStatic new_String: nil) getText asString = 'String: null'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testOutOfRangeValues

	self should: [classStatic new_byte: 200] raise: Error.
	self should: [classStatic new_byte: 1000] raise: Error.
	self should: [classStatic new_short: 1000000] raise: Error.
	self should: [classStatic new_int: 6000000000] raise: Error.
	self should: [classStatic new_long: 100 factorial] raise: Error.! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testPointArgument

	| jap p3x4 |

	jap := jvm findClass: #'java.awt.Point'.
	p3x4 := jap new_int: 3 int: 4.

	self should: [(classStatic new_Point: p3x4) getText asString = 'Point: java.awt.Point[x=3,y=4]'].		"JVM specific ??"! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testShortArgument

	self should: [(classStatic new_short: 0) getText asString = 'short: 0'].
	self should: [(classStatic new_short: 100) getText asString = 'short: 100'].
	self should: [(classStatic new_short: -100) getText asString = 'short: -100'].
	self should: [(classStatic new_short: 1000) getText asString = 'short: 1000'].
	self should: [(classStatic new_short: -1000) getText asString = 'short: -1000'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testStringArgument

	self should: [(classStatic new_String: 'Hi there!!') getText asString = 'String: Hi there!!'].! !

!JNIPortGeneratedConstructorsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testTwoArguments

	self should: [(classStatic new_int: 1 float: 1.5) getText asString = 'int: 1 float: 1.5'].! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedFieldAccessTest
	instanceVariableNames: 'instance classStatic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedFieldAccessTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org

Note, we don't test writing of "final" fields, 'cos it works in every case (i.e. JNI lets us do it) but it means nothing, so there's
no point in testing it.!

!JNIPortGeneratedFieldAccessTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'FieldAccess'.! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	classStatic := self javaTestClass.
	instance := classStatic new.! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	classStatic := instance := nil.
	super tearDown.! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNoGettersGeneratedForNonpublicFields

	| generatorSettings includeProtectedFields includeDefaultAccessFields includePrivateFields |
	generatorSettings := jvm usesGhostClasses ifTrue: [jvm settings ghostClassSettings] ifFalse: [jvm settings wrapperGeneratorSettings].
	includeProtectedFields := generatorSettings includeProtectedFields.
	includeDefaultAccessFields := generatorSettings includeDefaultAccessFields.
	includePrivateFields := generatorSettings includePrivateFields.
	
	self assert: (includeProtectedFields not xor: (instance class includesSelector: #get_protectedIntField)).
	self assert: (includeDefaultAccessFields not xor: (instance class includesSelector: #get_defaultIntField)).
	self assert: (includePrivateFields not xor: (instance class includesSelector: #get_privateIntField)).

	self assert: (includeProtectedFields not xor: (instance class includesSelector: #get_protectedFinalIntField)).
	self assert: (includeDefaultAccessFields not xor: (instance class includesSelector: #get_defaultFinalIntField)).
	self assert: (includePrivateFields not xor: (instance class includesSelector: #get_privateFinalIntField)).

	self assert: (includeProtectedFields not xor: (classStatic class includesSelector: #get_protectedStaticIntField)).
	self assert: (includeDefaultAccessFields not xor: (classStatic class includesSelector: #get_defaultStaticIntField)).
	self assert: (includePrivateFields not xor: (classStatic class includesSelector: #get_privateStaticIntField)).

	self assert: (includeProtectedFields not xor: (classStatic class includesSelector: #get_protectedStaticFinalIntField)).
	self assert: (includeDefaultAccessFields not xor: (classStatic class includesSelector: #get_defaultStaticFinalIntField)).
	self assert: (includePrivateFields not xor: (classStatic class includesSelector: #get_privateStaticFinalIntField)).! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNoSettersGeneratedForFinalFields

	self shouldnt: [instance class includesSelector: #set_publicFinalIntField:].
	self shouldnt: [instance class includesSelector: #set_protectedFinalIntField:].
	self shouldnt: [instance class includesSelector: #set_defaultFinalIntField:].
	self shouldnt: [instance class includesSelector: #set_privateFinalIntField:].

	self shouldnt: [classStatic class includesSelector: #set_publicStaticFinalIntField:].
	self shouldnt: [classStatic class includesSelector: #set_protectedStaticFinalIntField:].
	self shouldnt: [classStatic class includesSelector: #set_defaultStaticFinalIntField:].
	self shouldnt: [classStatic class includesSelector: #set_privateStaticFinalIntField:].! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNoSettersGeneratedForNonpublicFields

	| generatorSettings includeProtectedFields includeDefaultAccessFields includePrivateFields |
	generatorSettings := jvm usesGhostClasses ifTrue: [jvm settings ghostClassSettings] ifFalse: [jvm settings wrapperGeneratorSettings].
	includeProtectedFields := generatorSettings includeProtectedFields.
	includeDefaultAccessFields := generatorSettings includeDefaultAccessFields.
	includePrivateFields := generatorSettings includePrivateFields.

	self assert: (includeProtectedFields not xor: (instance class includesSelector: #set_protectedIntField:)).
	self assert: (includeDefaultAccessFields not xor: (instance class includesSelector: #set_defaultIntField:)).
	self assert: (includePrivateFields not xor: (instance class includesSelector: #set_privateIntField:)).

	self assert: (includeProtectedFields not xor: (classStatic class includesSelector: #set_protectedStaticIntField:)).
	self assert: (includeDefaultAccessFields not xor: (classStatic class includesSelector: #set_defaultStaticIntField:)).
	self assert: (includePrivateFields not xor: (classStatic class includesSelector: #set_privateStaticIntField:)).! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadPublicClassField

	self should: [classStatic get_publicStaticIntField = 101].! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadPublicFinalClassField

	self should: [classStatic get_publicStaticFinalIntField = 111].! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadPublicFinalInstanceField

	self should: [instance get_publicFinalIntField = 11].! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadPublicInstanceField

	self should: [instance get_publicIntField = 1].! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testWritePublicClassField

	classStatic set_publicStaticIntField: 0.
	self should: [classStatic get_publicStaticIntField = 0].
	classStatic set_publicStaticIntField: 101.
	self should: [classStatic get_publicStaticIntField = 101].! !

!JNIPortGeneratedFieldAccessTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testWritePublicInstanceField

	self should: [instance get_publicIntField = 1].
	instance set_publicIntField: 0.
	self should: [instance get_publicIntField = 0].! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedFieldsTest
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedFieldsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedFieldsTest class methodsFor: 'Testing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
isAbstract

	^self = JNIPortGeneratedFieldsTest.! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
dontTestTypeErrors

	"unfortunately we can't use this test since the JVM doesn't actually check the types
	for fields written via JNI"

	| jap |

	jap := jvm findClass: #'java.awt.Point'.
	self
		should: [subject set_stringField: jap new]
		raise: Error.
	self should: [(subject get_stringField) asString = 'Hi there'].! !

!JNIPortGeneratedFieldsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	subject := self subject.! !

!JNIPortGeneratedFieldsTest methodsFor: 'accessing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
subject

	self subclassResponsibility.! !

!JNIPortGeneratedFieldsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	subject := nil.
	super tearDown.! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessBooleanField

	self should: [subject get_booleanField = true].

	subject set_booleanField: false.
	self should: [subject get_booleanField = false].
	self should: [subject callBooleanMethod: 'isBooleanFalse'].

	subject set_booleanField: true.
	self should: [subject get_booleanField = true].
	self should: [subject callBooleanMethod: 'isBooleanTrue'].! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessByteField

	self should: [subject get_byteField = 22].

	subject set_byteField: 0.
	self should: [(subject getByteField: 'byteField') = 0].
	self should: [subject callBooleanMethod: 'isByteZero'].

	subject set_byteField: 33.
	self should: [subject get_byteField = 33].
	self should: [subject callBooleanMethod: 'isByte33'].

	subject set_byteField: -33.
	self should: [subject get_byteField = -33].
	self should: [subject callBooleanMethod: 'isByteMinus33'].

	subject set_byteField: 22.
	self should: [subject get_byteField = 22].! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessCharField

	self should: [subject get_charField = $!!].

	subject set_charField: $M.
	self should: [subject get_charField = $M].
	self should: [subject callBooleanMethod: 'isCharM'].

	subject set_charField: 0.
	self should: [subject get_charField = (Character codePoint: 0)].
	self should: [subject callBooleanMethod: 'isCharZero'].

	subject set_charField: 16rA.
	self should: [subject get_charField = (Character codePoint: 16rA)].
	self should: [subject callBooleanMethod: 'isChar0xA'].

	subject set_charField: 16rAA.
	self should: [subject get_charField = (Character codePoint: 16rAA)].
	self should: [subject callBooleanMethod: 'isChar0xAA'].

	subject set_charField: 16rAAA.
	self should: [subject get_charField = (Character codePoint: 16rAAA)].
	self should: [subject callBooleanMethod: 'isChar0xAAA'].

	subject set_charField: 16rAAAA.
	self should: [subject get_charField = (Character codePoint: 16rAAAA)].
	self should: [subject callBooleanMethod: 'isChar0xAAAA'].

	subject set_charField: $!!.
	self should: [subject get_charField = $!!].! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessDoubleField

	self should: [subject get_doubleField = 22.0].

	subject set_doubleField: 0.0.
	self should: [subject get_doubleField = 0.0].
	self should: [subject callBooleanMethod: 'isDoubleZero'].

	subject set_doubleField: 33.0.
	self should: [subject get_doubleField = 33.0].
	self should: [subject callBooleanMethod: 'isDouble33'].

	subject set_doubleField: -33.0.
	self should: [subject get_doubleField = -33.0].
	self should: [subject callBooleanMethod: 'isDoubleMinus33'].

	subject set_doubleField: 33.		"NB: passing an Integer, expecting coercion to double"
	self should: [subject get_doubleField = 33.0].
	self should: [subject callBooleanMethod: 'isDouble33'].

	subject set_doubleField: 22.0.
	self should: [subject get_doubleField = 22.0].! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessFloatField

	self should: [subject get_floatField = 22.0].

	subject set_floatField: 0.0.
	self should: [subject get_floatField = 0.0].
	self should: [subject callBooleanMethod: 'isFloatZero'].

	subject set_floatField: 33.0.
	self should: [subject get_floatField = 33.0].
	self should: [subject callBooleanMethod: 'isFloat33'].

	subject set_floatField: -33.0.
	self should: [subject get_floatField = -33.0].
	self should: [subject callBooleanMethod: 'isFloatMinus33'].

	subject set_floatField: 33.		"NB: passing an Integer, expecting coercion to float"
	self should: [subject get_floatField = 33.0].
	self should: [subject callBooleanMethod: 'isFloat33'].

	subject set_floatField: 22.0.
	self should: [subject get_floatField = 22.0].! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessIntField

	self should: [subject get_intField = 22].

	subject set_intField: 0.
	self should: [(subject getIntField: 'intField') = 0].
	self should: [subject callBooleanMethod: 'isIntZero'].

	subject set_intField: 33.
	self should: [subject get_intField = 33].
	self should: [subject callBooleanMethod: 'isInt33'].

	subject set_intField: -33.
	self should: [subject get_intField = -33].
	self should: [subject callBooleanMethod: 'isIntMinus33'].

	subject set_intField: 22.
	self should: [subject get_intField = 22].! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessLongField

	self should: [subject get_longField = 22].

	subject set_longField: 0.
	self should: [(subject getLongField: 'longField') = 0].
	self should: [subject callBooleanMethod: 'isLongZero'].

	subject set_longField: 33.
	self should: [subject get_longField = 33].
	self should: [subject callBooleanMethod: 'isLong33'].

	subject set_longField: -33.
	self should: [subject get_longField = -33].
	self should: [subject callBooleanMethod: 'isLongMinus33'].

	subject set_longField: 22.
	self should: [subject get_longField = 22].! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessNonExistantField

	| exceptionClass |

	exceptionClass := MessageNotUnderstood.

	self
		should: [subject get_nonExistantField]
		raise: exceptionClass.

	self
		should: [subject set_nonExistantField: nil]
		raise: exceptionClass.! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessPointField

	| jap p3x4 p33x45 point |

	jap := jvm findClass: #'java.awt.Point'.
	p3x4 := jap new_int: 3 int: 4.

	point := subject get_pointField.
	self should: [point equals: p3x4].

	subject set_pointField: nil.
	self should: [subject get_pointField = nil].
	self should: [subject callBooleanMethod: 'isPointNull'].

	subject set_pointField: jap new.
	self should: [subject callBooleanMethod: 'isPointZero'].

	p33x45 := jap new_int: 33 int: 45.
	subject set_pointField: p33x45.
	self should: [subject get_pointField = p33x45].
	self should: [subject callBooleanMethod: 'isPoint33x45'].

	subject set_pointField: point.
	self should: [subject get_pointField = point].! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessShortField

	self should: [subject get_shortField = 22].

	subject set_shortField: 0.
	self should: [(subject getShortField: 'shortField') = 0].
	self should: [subject callBooleanMethod: 'isShortZero'].

	subject set_shortField: 33.
	self should: [subject get_shortField = 33].
	self should: [subject callBooleanMethod: 'isShort33'].

	subject set_shortField: -33.
	self should: [subject get_shortField = -33].
	self should: [subject callBooleanMethod: 'isShortMinus33'].

	subject set_shortField: 22.
	self should: [subject get_shortField = 22].! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testAccessStringField

	self should: [subject get_stringField asString = 'Hi there'].

	subject set_stringField: nil.
	self should: [subject get_stringField = nil].
	self should: [subject callBooleanMethod: 'isStringNull'].

	subject set_stringField: '33'.
	self should: [subject get_stringField asString = '33'].
	self should: [subject callBooleanMethod: 'isString33'].

	subject set_stringField: ''.
	self should: [subject get_stringField isEmpty].
	self should: [subject callBooleanMethod: 'isStringEmpty'].

	subject set_stringField: 'Hi there'.
	self should: [subject get_stringField asString = 'Hi there'].! !

!JNIPortGeneratedFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testOutOfRangeValues

	self
		should: [subject set_byteField: 200]
		raise: Error.
	self should: [subject get_byteField = 22].

	self
		should: [subject set_byteField: 1000]
		raise: Error.
	self should: [subject get_byteField = 22].

	self
		should: [subject set_shortField: 1000000]
		raise: Error.
	self should: [subject get_shortField = 22].

	self
		should: [subject set_intField: 6000000000]
		raise: Error.
	self should: [subject get_intField = 22].

	self
		should: [subject set_longField: 100 factorial]
		raise: Error.
	self should: [subject get_longField = 22].! !

JNIPortGeneratedFieldsTest subclass: #JNIPortGeneratedInstanceFieldsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedInstanceFieldsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedInstanceFieldsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'InstanceFields'.! !

!JNIPortGeneratedInstanceFieldsTest methodsFor: 'accessing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
subject

	^ self javaTestClass new.! !

JNIPortGeneratedFieldsTest subclass: #JNIPortGeneratedStaticFieldsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedStaticFieldsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedStaticFieldsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'StaticFields'.! !

!JNIPortGeneratedStaticFieldsTest methodsFor: 'accessing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
subject

	^ self javaTestClass.! !

!JNIPortGeneratedStaticFieldsTest methodsFor: 'initialize-release' stamp: 'JoachimGeidel 5/30/2010 13:13'!
tearDown
	"testOutOfRangeValues may leave modified values in the StaticFields static fields if the out of range values can actually be stored, instead of leading to an Exception. Reset them such that other tests relying on the initial values if the static fields don't fail."

	jvm isDead 
		ifFalse: 
			[subject setByteField: 'byteField' to: 22.
			subject setShortField: 'shortField' to: 22.
			subject setIntField: 'intField' to: 22.
			subject setLongField: 'longField' to: 22.
			subject setFloatField: 'floatField' to: 22.0.
			subject setDoubleField: 'doubleField' to: 22.0.].
	super tearDown! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedHiddenFieldsTest
	instanceVariableNames: 'instance classStatic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedHiddenFieldsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'HidingFields'.! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	classStatic := self javaTestClass.
	instance := classStatic new.! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	classStatic := instance := nil.
	super tearDown.! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testClassFieldIsInherited

	self should: [classStatic get_staticBooleanField = true].! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNoSettersGenerated

	self shouldnt: [classStatic class includesSelector: #set_interfaceIntField:].! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testOverloadedByTypeField

	| class |
	class := self overloadedByTypeClass.
	class isNil
		ifTrue: 
			[JNIPortNotification
				raiseSignal: thisContext printString , ' not run (classfile generation is not installed?)'.
			^self].
	self should: [class get_field] raise: AmbiguousJavaMethodError.
	self should: [class get_int_field = 33].
	self should: [class get_boolean_field = false]! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadAmbiguousField

	"NB: we should be reading the field in the *interface* "

	"JRockit wrongly picks up the class field"

	self should: [classStatic get_ambiguousIntField = -100].! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadClassField

	self should: [classStatic get_staticIntField = 666].! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadInstanceField

	self should: [instance get_intField = 6].! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadInterfaceField

	self should: [classStatic get_interfaceIntField = 66].! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testWriteAmbiguousField

	"NB: we would be writing the field in the *interface* "

	self
		should: [classStatic set_ambiguousIntField: 0]
		raise: Error.! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testWriteClassField

	classStatic set_staticIntField: 0.
	self should: [classStatic get_staticIntField = 0].
	classStatic set_staticIntField: 666.
	self should: [classStatic get_staticIntField = 666].! !

!JNIPortGeneratedHiddenFieldsTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testWriteInstanceField

	self should: [instance get_intField = 6].
	instance set_intField: 0.
	self should: [instance get_intField = 0].! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedHiddenMethodsTest
	instanceVariableNames: 'instance classStatic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedHiddenMethodsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
interface

	^ self javaTestClass: 'InheritedMethodsInterface'.! !

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'HidingMethods'.! !

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	classStatic := self javaTestClass.
	instance := classStatic new.! !

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	classStatic := instance := nil.
	super tearDown.! !

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallClassMethod

	self should: [classStatic staticIntMethod = 666].! !

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallInstanceMethod

	self should: [instance intMethod = 6].! !

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallMethodAsAnInterface

	| asA |

	asA := instance asInstanceOf: self interface.

	"different behaviour between ghost classes and statically generated wrappers in this case"
	(jvm usesGhostClasses and: [jvm settings ghostClassSettings useGhostInstancesForInterfaces not])
		ifTrue:
			["since #as: doesn't fit with ghost clases, this is supposed to DNU,
			unless a static wrapper for the interface has also been generated
			or ghost 'instance' wrappers are enabled for interfaces"
			self
				should: [asA interfaceIntMethod = 6666]
				raise: MessageNotUnderstood]
		ifFalse:
			[self should: [asA interfaceIntMethod = 6666]].! !

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallSuperClassMethod

	self should: [classStatic super staticIntMethod = 222].! !

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallSuperInstanceMethod

	"since #super doesn't fit with ghost clases, this is supposed to DNU"
	self
		should: [instance super intMethod = 2]
		raise: MessageNotUnderstood.! !

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testClassMethodIsInherited

	self should: [classStatic staticBooleanMethod = true].! !

!JNIPortGeneratedHiddenMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testOverloadedByTypeMethod

	| class subject |
	class := self overloadedByTypeClass.
	class isNil
		ifTrue: 
			[JNIPortNotification
				raiseSignal: thisContext printString , ' not run (classfile generation is not installed?)'.
			^self].
	subject := class new.
	self should: [subject method] raise: AmbiguousJavaMethodError.
	self should: [subject method_int = 22].
	self should: [subject method_double = 10.0]! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedInheritedFieldsTest
	instanceVariableNames: 'instance classStatic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedInheritedFieldsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedInheritedFieldsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'InheritedFields'.! !

!JNIPortGeneratedInheritedFieldsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	classStatic := self javaTestClass.
	instance := classStatic new.! !

!JNIPortGeneratedInheritedFieldsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	classStatic := instance := nil.
	super tearDown.! !

!JNIPortGeneratedInheritedFieldsTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadClassField

	self should: [classStatic get_staticIntField = 222].! !

!JNIPortGeneratedInheritedFieldsTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadInstanceField

	self should: [instance get_intField = 2].! !

!JNIPortGeneratedInheritedFieldsTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testWriteClassField

	classStatic set_staticIntField: 0.
	self should: [classStatic get_staticIntField = 0].
	classStatic set_staticIntField: 222.
	self should: [classStatic get_staticIntField = 222].! !

!JNIPortGeneratedInheritedFieldsTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testWriteInstanceField

	self should: [instance get_intField = 2].
	instance set_intField: 0.
	self should: [instance get_intField = 0].! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedInheritedMethodsTest
	instanceVariableNames: 'instance classStatic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedInheritedMethodsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedInheritedMethodsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'InheritedMethods'.! !

!JNIPortGeneratedInheritedMethodsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	classStatic := self javaTestClass.
	instance := classStatic new.! !

!JNIPortGeneratedInheritedMethodsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	classStatic := instance := nil.
	super tearDown.! !

!JNIPortGeneratedInheritedMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallAbstractMethod

	self should: [instance abstractIntMethod = 22].! !

!JNIPortGeneratedInheritedMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallClassMethod

	self should: [classStatic staticIntMethod = 222].! !

!JNIPortGeneratedInheritedMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallInstanceMethod

	self should: [instance intMethod = 2].! !

!JNIPortGeneratedInheritedMethodsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallInterfaceMethod

	self should: [instance interfaceIntMethod = 2222].! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedInhertedInterfaceFieldsTest
	instanceVariableNames: 'classStatic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedInhertedInterfaceFieldsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedInhertedInterfaceFieldsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'InheritedInterfaceFields'.! !

!JNIPortGeneratedInhertedInterfaceFieldsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	classStatic := self javaTestClass.! !

!JNIPortGeneratedInhertedInterfaceFieldsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	classStatic := nil.
	super tearDown.! !

!JNIPortGeneratedInhertedInterfaceFieldsTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNoSettersGenerated

	self shouldnt: [classStatic class includesSelector: #set_interfaceIntField:].! !

!JNIPortGeneratedInhertedInterfaceFieldsTest methodsFor: 'reading' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadField

	self should: [classStatic get_interfaceIntField = 33].! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedInterfaceFieldsTest
	instanceVariableNames: 'classStatic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedInterfaceFieldsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedInterfaceFieldsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'InterfaceFields'.! !

!JNIPortGeneratedInterfaceFieldsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	classStatic := self javaTestClass.! !

!JNIPortGeneratedInterfaceFieldsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	classStatic := nil.
	super tearDown.! !

!JNIPortGeneratedInterfaceFieldsTest methodsFor: 'writing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNoSettersGenerated

	self shouldnt: [classStatic class includesSelector: #set_publicIntField:].
	self shouldnt: [classStatic class includesSelector: #set_publicFinalIntField:].
	self shouldnt: [classStatic class includesSelector: #set_publicStaticIntField:].
	self shouldnt: [classStatic class includesSelector: #set_publicStaticFinalIntField:].
	self shouldnt: [classStatic class includesSelector: #set_defaultIntField:].
	self shouldnt: [classStatic class includesSelector: #set_defaultFinalIntField:].
	self shouldnt: [classStatic class includesSelector: #set_defaultStaticIntField:].
	self shouldnt: [classStatic class includesSelector: #set_defaultStaticFinalIntField:].! !

!JNIPortGeneratedInterfaceFieldsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testReadFields

	self should: [classStatic get_publicIntField = 1].
	self should: [classStatic get_publicFinalIntField = 2].
	self should: [classStatic get_publicStaticIntField = 3].
	self should: [classStatic get_publicStaticFinalIntField = 4].
	self should: [classStatic get_defaultIntField = 5].
	self should: [classStatic get_defaultFinalIntField = 6].
	self should: [classStatic get_defaultStaticIntField = 7].
	self should: [classStatic get_defaultStaticFinalIntField = 8].! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedMethodAccessTest
	instanceVariableNames: 'instance classStatic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedMethodAccessTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedMethodAccessTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'MethodAccess'.! !

!JNIPortGeneratedMethodAccessTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	classStatic := self javaTestClass.
	instance := classStatic new.! !

!JNIPortGeneratedMethodAccessTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	classStatic := instance := nil.
	super tearDown.! !

!JNIPortGeneratedMethodAccessTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallPublicClassMethod

	self should: [classStatic publicStaticIntMethod = 101].! !

!JNIPortGeneratedMethodAccessTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallPublicFinalClassMethod

	self should: [classStatic publicStaticFinalIntMethod = 111].! !

!JNIPortGeneratedMethodAccessTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallPublicFinalInstanceMethod

	self should: [instance publicFinalIntMethod = 11].! !

!JNIPortGeneratedMethodAccessTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallPublicInstanceMethod

	self should: [instance publicIntMethod = 1].! !

!JNIPortGeneratedMethodAccessTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNoWrappersGeneratedForNonpublicMethods
	| generatorSettings includeProtectedMethods includeDefaultAccessMethods includePrivateMethods |
	generatorSettings := jvm usesGhostClasses 
				ifTrue: [jvm settings ghostClassSettings]
				ifFalse: [jvm settings wrapperGeneratorSettings].
	includeProtectedMethods := generatorSettings includeProtectedMethods.
	includeDefaultAccessMethods := generatorSettings includeDefaultAccessMethods.
	includePrivateMethods := generatorSettings includePrivateMethods.

	self assert: (includeProtectedMethods not xor: (instance class includesSelector: #protectedIntMethod)).
	self assert: (includeDefaultAccessMethods not xor: (instance class includesSelector: #defaultIntMethod)).
	self assert: (includePrivateMethods not xor: (instance class includesSelector: #privateIntMethod)).

	self assert: (includeProtectedMethods not xor: (instance class includesSelector: #protectedFinalIntMethod)).
	self assert: (includeDefaultAccessMethods not xor: (instance class includesSelector: #defaultFinalIntMethod)).
	self assert: (includePrivateMethods not xor: (instance class includesSelector: #privateFinalIntMethod)).

	self assert: (includeProtectedMethods not xor: (classStatic class includesSelector: #protectedStaticIntMethod)).
	self assert: (includeDefaultAccessMethods not xor: (classStatic class includesSelector: #defaultStaticIntMethod)).
	self assert: (includePrivateMethods not xor: (classStatic class includesSelector: #privateStaticIntMethod)).

	self assert: (includeProtectedMethods not xor: (classStatic class includesSelector: #protectedStaticFinalIntMethod)).
	self assert: (includeDefaultAccessMethods not xor: (classStatic class includesSelector: #defaultStaticFinalIntMethod)).
	self assert: (includePrivateMethods not xor: (classStatic class includesSelector: #privateStaticFinalIntMethod))! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedMethodArgumentsTest
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedMethodArgumentsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

JNIPortGeneratedMethodArgumentsTest subclass: #JNIPortGeneratedInstanceMethodArgumentsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedInstanceMethodArgumentsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedInstanceMethodArgumentsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'InstanceMethodArguments'.! !

!JNIPortGeneratedInstanceMethodArgumentsTest methodsFor: 'accessing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
subject

	^ self javaTestClass new.! !

!JNIPortGeneratedMethodArgumentsTest class methodsFor: 'Testing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
isAbstract

	^self = JNIPortGeneratedMethodArgumentsTest.! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
dontTestTypeErrors

	"unfortunately we can't use this test since the JVM doesn't actually check the types
	and therefore tends to crash..."

	| string |

	string := 'Hi there' asJavaString: jvm.
	self
		should: [subject halt method_Point: string]
		raise: JavaException.! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	subject := self subject.! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'accessing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
subject

	self subclassResponsibility.! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	subject := nil.
	super tearDown.! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testBooleanArgument

	self should: [(subject method_boolean: true) asString = 'boolean: true'].
	self should: [(subject method_boolean: false) asString = 'boolean: false'].! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testByteArgument

	self should: [(subject method_byte: 0) asString = 'byte: 0'].
	self should: [(subject method_byte: 100) asString = 'byte: 100'].
	self should: [(subject method_byte: -100) asString = 'byte: -100'].! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCharArgument

	self should: [(subject method_char: $!!) asString = 'char: !!'].
	self should: [(subject method_char: $A) asString = 'char: A'].! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:34'!
testDoubleArgument

	self should: [(subject method_double: 0.0 asDouble) asString = 'double: 0.0'].
	self should: [(subject method_double: 100.0 asDouble) asString = 'double: 100.0'].
	self should: [(subject method_double: -100.0 asDouble) asString = 'double: -100.0'].
	self should: [(subject method_double: 1000.0 asDouble) asString = 'double: 1000.0'].
	self should: [(subject method_double: -1000.0 asDouble) asString = 'double: -1000.0'].
	self should: [(subject method_double: 1000000.0 asDouble) asString = 'double: 1000000.0'].
	self should: [(subject method_double: -1000000.0 asDouble) asString = 'double: -1000000.0'].
	self should: [(subject method_double: (Number readFromString: '1000000000000.0d')) asString = 'double: 1.0E12'].		"JVM specific ??"
	self should: [(subject method_double: (Number readFromString: '-1000000000000.0d')) asString = 'double: -1.0E12'].		"JVM specific ??"! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testFloatArgument

	self should: [(subject method_float: 0.0 asFloat) asString = 'float: 0.0'].
	self should: [(subject method_float: 100.0 asFloat) asString = 'float: 100.0'].
	self should: [(subject method_float: -100.0 asFloat) asString = 'float: -100.0'].
	self should: [(subject method_float: 1000.0 asFloat) asString = 'float: 1000.0'].
	self should: [(subject method_float: -1000.0 asFloat) asString = 'float: -1000.0'].
	self should: [(subject method_float: 1000000.0 asFloat) asString = 'float: 1000000.0'].
	self should: [(subject method_float: -1000000.0 asFloat) asString = 'float: -1000000.0'].! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testIntArgument

	self should: [(subject method_int: 0) asString = 'int: 0'].
	self should: [(subject method_int: 100) asString = 'int: 100'].
	self should: [(subject method_int: -100) asString = 'int: -100'].
	self should: [(subject method_int: 1000) asString = 'int: 1000'].
	self should: [(subject method_int: -1000) asString = 'int: -1000'].
	self should: [(subject method_int: 1000000) asString = 'int: 1000000'].
	self should: [(subject method_int: -1000000) asString = 'int: -1000000'].! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testLongArgument

	self should: [(subject method_long: 0) asString = 'long: 0'].
	self should: [(subject method_long: 100) asString = 'long: 100'].
	self should: [(subject method_long: -100) asString = 'long: -100'].
	self should: [(subject method_long: 1000) asString = 'long: 1000'].
	self should: [(subject method_long: -1000) asString = 'long: -1000'].
	self should: [(subject method_long: 1000000) asString = 'long: 1000000'].
	self should: [(subject method_long: -1000000) asString = 'long: -1000000'].
	self should: [(subject method_long: 1000000000000) asString = 'long: 1000000000000'].
	self should: [(subject method_long: -1000000000000) asString = 'long: -1000000000000'].! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNoArguments

	self should: [(subject method) asString = '<nothing>'].! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNullArgument

	self should: [(subject method_String: nil) asString = 'String: null'].! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testOutOfRangeValues

	self should: [subject method_byte: 200] raise: Error.
	self should: [subject method_byte: 1000] raise: Error.
	self should: [subject method_short: 1000000] raise: Error.
	self should: [subject method_int: 6000000000] raise: Error.
	self should: [subject method_long: 100 factorial] raise: Error.! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testPointArgument

	| jap p3x4 |

	jap := jvm findClass: #'java.awt.Point'.
	p3x4 := jap new_int: 3 int: 4.

	self should: [(subject method_Point: p3x4) asString = 'Point: java.awt.Point[x=3,y=4]'].		"JVM specific ??"! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testShortArgument

	self should: [(subject method_short: 0) asString = 'short: 0'].
	self should: [(subject method_short: 100) asString = 'short: 100'].
	self should: [(subject method_short: -100) asString = 'short: -100'].
	self should: [(subject method_short: 1000) asString = 'short: 1000'].
	self should: [(subject method_short: -1000) asString = 'short: -1000'].! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testStringArgument

	self should: [(subject method_String: 'Hi there!!') asString = 'String: Hi there!!'].! !

!JNIPortGeneratedMethodArgumentsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testTwoArguments

	self should: [(subject method_int: 1 float: 1.5) asString = 'int: 1 float: 1.5'].! !

JNIPortGeneratedMethodArgumentsTest subclass: #JNIPortGeneratedStaticMethodArgumentsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedStaticMethodArgumentsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedStaticMethodArgumentsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'StaticMethodArguments'.! !

!JNIPortGeneratedStaticMethodArgumentsTest methodsFor: 'accessing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
subject

	^ self javaTestClass.! !

GenericJNIPortRegressionTest subclass: #JNIPortGeneratedMethodReturnsTest
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedMethodReturnsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

JNIPortGeneratedMethodReturnsTest subclass: #JNIPortGeneratedInstanceMethodReturnsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedInstanceMethodReturnsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedInstanceMethodReturnsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'InstanceMethods'.! !

!JNIPortGeneratedInstanceMethodReturnsTest methodsFor: 'accessing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
subject

	^ self javaTestClass new.! !

!JNIPortGeneratedMethodReturnsTest class methodsFor: 'Testing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
isAbstract

	^self = JNIPortGeneratedMethodReturnsTest.! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
setUp

	super setUp.
	subject := self subject.! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'accessing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
subject

	self subclassResponsibility.! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'Running' stamp: 'JoachimGeidel 5/29/2010 18:09'!
tearDown

	subject := nil.
	super tearDown.! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testBooleanMethodReturn

	self should: [subject booleanMethod = true].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testByteMethodReturn

	self should: [subject byteMethod = 20].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCallNonExistantMethod

	self
		should: [subject nonExistantMethod]
		raise: MessageNotUnderstood.! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testCharMethodReturn

	self should: [subject charMethod = $!!].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testDoubleMethodReturn

	self should: [subject doubleMethod = 25.0].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testFloatMethodReturn

	self should: [subject floatMethod = 24.0].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testIntMethodReturn

	self should: [subject intMethod = 22].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testLongMethodReturn

	self should: [subject longMethod = 23].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testNullMethodReturn

	self should: [subject nullMethod isNil].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testPointMethodReturn

	| point |

	point := subject pointMethod.
	self should: [point get_x = 3].
	self should: [point get_y = 4].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testShortMethodReturn

	self should: [subject shortMethod = 21].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testStringMethodReturn

	self should: [subject stringMethod asString = 'Hi there'].! !

!JNIPortGeneratedMethodReturnsTest methodsFor: 'unit tests' stamp: 'JoachimGeidel 5/29/2010 18:09'!
testVoidMethodReturn

	self should: [subject voidMethod == subject].! !

JNIPortGeneratedMethodReturnsTest subclass: #JNIPortGeneratedStaticMethodReturnsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JNIPort-Tests-Java-WrapperGeneration'!

!JNIPortGeneratedStaticMethodReturnsTest commentStamp: 'JoachimGeidel 5/29/2010 18:09' prior: 0!
Copyright  Chris Uppal, 2002, 2003.
chris.uppal@metagnostic.org!

!JNIPortGeneratedStaticMethodReturnsTest methodsFor: 'constants' stamp: 'JoachimGeidel 5/29/2010 18:09'!
javaTestClassName

	^ 'StaticMethods'.! !

!JNIPortGeneratedStaticMethodReturnsTest methodsFor: 'accessing' stamp: 'JoachimGeidel 5/29/2010 18:09'!
subject

	^ self javaTestClass.! !
